#!/bin/sh

# Unzip openjdk source zip.
unzip -q $1

# Remove win32 sources, some of which have questionable license
# headers.
rm -rf \
  openjdk/hotspot/agent/src/share/classes/sun/jvm/hotspot/debugger/win32 \
  openjdk/hotspot/agent/src/share/classes/sun/jvm/hotspot/debugger/windbg \
  openjdk/hotspot/agent/src/share/classes/sun/jvm/hotspot/runtime/win32_amd64 \
  openjdk/hotspot/agent/src/share/classes/sun/jvm/hotspot/runtime/win32_ia64 \
  openjdk/hotspot/agent/src/share/classes/sun/jvm/hotspot/runtime/win32_x86

# Remove idl sources with questionable license headers.
rm -f \
  openjdk/j2se/src/share/classes/com/sun/tools/corba/se/idl/grammar.idl \
  openjdk/j2se/src/share/classes/com/sun/tools/corba/se/idl/first.set \
  openjdk/j2se/src/share/classes/com/sun/tools/corba/se/idl/grammar3.idl \
  openjdk/j2se/src/share/classes/com/sun/tools/corba/se/idl/follow.set

# Remove test sources with questionable license headers.
rm -f \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4168625Resource3.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4168625Resource3_en_IE.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4165815Test.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4177489_Resource_jf.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4168625Resource3_en_CA.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4168625Getter.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4177489Test.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4168625Resource.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4168625Resource2.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4168625Resource3_en_US.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4083270Test.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4168625Resource3_en.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4177489_Resource.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4168625Test.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4168625Resource2_en_US.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4168625Class.java \
   openjdk/j2se/test/java/util/Locale/Bug4175998Test.java \
   openjdk/j2se/test/java/util/ResourceBundle/RBTestFmwk.java \
   openjdk/j2se/test/java/util/ResourceBundle/TestResource_fr.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4179766Resource.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4179766Getter.java \
   openjdk/j2se/test/java/util/ResourceBundle/Bug4179766Class.java \
   openjdk/j2se/test/java/util/ResourceBundle/TestResource.java \
   openjdk/j2se/test/java/util/ResourceBundle/FakeTestResource.java \
   openjdk/j2se/test/java/util/ResourceBundle/TestResource_de.java \
   openjdk/j2se/test/java/util/ResourceBundle/TestBug4179766.java \
   openjdk/j2se/test/java/util/ResourceBundle/TestResource_fr_CH.java \
   openjdk/j2se/test/java/util/ResourceBundle/ResourceBundleTest.java \
   openjdk/j2se/test/java/util/ResourceBundle/TestResource_it.java \
   openjdk/j2se/test/java/util/Locale/PrintDefaultLocale.java \
   openjdk/j2se/test/java/util/Locale/LocaleTest.java \
   openjdk/j2se/test/java/util/Locale/LocaleTestFmwk.java \
   openjdk/j2se/test/java/util/Locale/Bug4184873Test.java \
   openjdk/j2se/test/sun/text/resources/LocaleDataTest.java

# Remove jhat sources.  Most have questionable license headers.
rm -rf \
  openjdk/j2se/src/share/classes/com/sun/tools/hat \
  openjdk/j2se/test/sun/tools/jhat

# Remove J2DBench sources, some of which have questionable license
# headers.
rm -rf \
  openjdk/j2se/src/share/demo/java2d/J2DBench

# Create new zip with new name.
NEW_ZIP=$(echo $1 | sed -e 's/\.zip/-fedora.zip/')
zip -rq $NEW_ZIP openjdk

# Remove old unzipped openjdk dir.
rm -rf openjdk
